#include <p32xxxx.h>			// always in first place to avoid conflict with const.h ON
#include "interrupt.h"
#include "../HardwareProfile.h"

#define	TRUE	1
/*
The following code example illustrates the DMA channel 0 configuration for a data transfer.
*/
void dma_test_1()
{
	IEC1CLR=0x00020000; // disable DMA channel 0 interrupts
	IFS1CLR=0x00020000; // clear existing DMA channel 0 interrupt flag
	IEC1CLR=0x00010000; // disable DMA channel 0 interrupts
	IFS1CLR=0x00010000; // clear existing DMA channel 0 interrupt flag
	DMACONSET=0x00008000; // enable the DMA controller
	DCH0CON=0x3; // channel off, pri 3, no chaining
	DCH0ECON=0; // no start or stop irqfs, no pattern match
// program the transfer
	DCH0SSA=0x1d010000; // transfer source physical address
	DCH0DSA=0x1d020000; // transfer destination physical address
	DCH0SSIZ=200; // source size 200 bytes
	DCH0DSIZ=200; // destination size 200 bytes
	DCH0CSIZ=200; // 200 bytes transferred per event
	DCH0INTCLR=0x00ff00ff; // clear existing events, disable all interrupts
	DCH0CONSET=0x80; // turn channel on
// initiate a transfer
	DCH0ECONSET=0x00000080; // set CFORCE to 1
// do something else
// poll to see that the transfer was done
	while(TRUE) {
		register int pollCnt; // use a poll counter.
// continuously polling the DMA controller in a tight
// loop would affect the performance of the DMA transfer
		int dmaFlags=DCH0INT;
		if( (dmaFlags&0xb) ) {
		// one of CHERIF (DCHxINT<0>), CHTAIF (DCHxINT<1>)
// or CHBCIF (DCHxINT<3>) flags set
		break; // transfer completed
	}
	pollCnt=100; // use an adjusted value here
	while(pollCnt--); // wait before reading again the DMA controller
	}
}
/*
// check the transfer completion result

31-1F
 {][hR[hpDMA`l̏
                   F
                   QƂ \31-5`lCxg̏ڍׂɂẮB
                   / *
                   ̃R[hł́Af[^]̂߂DMA`l0̍\
    }łB
                   * /
                   IEC1CLR = 0x00020000;
                   // DMA`l0̊荞݂𖳌ɂ
                   IFS1CLR = 0x00020000;
                   //NADMA`l0荞݃tO
                   IEC1CLR = 0x00010000;
                   // DMA`l0̊荞݂𖳌ɂ
                   IFS1CLR = 0x00010000;
                   //NADMA`l0荞݃tO
                   DMACONSET = 0x00008000;
                   // DMARg[L
                   DCH0CON = 0x3;
                   //`lItAPRI 3A`F[
                   CH0ECON = 0;
                   // IRQ́AȂp^[
                   }b`JnĂȂA܂͒~Ȃ
                   //vO̓]
                   DCH0SSA = 0x1d010000;
             //]̕AhX
             DCH0DSA = 0x1d020000;
             //]̕AhX
             DCH0SSIZ = 200;
             TCY200oCg//\[X
             DCH0DSIZ = 200;
             //TCY200oCg
             DCH0CSIZ = 200;
             CxgƂɓ]// 200oCg
DCH0INTCLR = 0x00ff00ff;
//NÃCxgAׂĂ̊荞݂𖳌ɂ
DCH0CONSET = 0x80;
//^[`l
//]Jn
DCH0ECONSET = 0x00000080;
// 1cforceZbg
//̂Ƃ͂
//_ł́A]sꂽƂmF
΂炭iTRUEj {
	int^pollCnto^;
	//|[OJE^gpĂ܂B
	//Aă|[O^CgDMARg[
	//[v́ADMA]̐\ɉe^
	int^dmaFlags = DCH0INT;
	iidmaFlags0XBj
	{
		VFtiDCHxINT <0>jACHTAIFiDCHxINT <1>j// 1
		ݒ//܂CHBCIFiDCHxINT <3>jtO
		j;
		//]
	}
	pollCnt = 100;
	//Œꂽlgp
	΂炭ipollCnt - j;
	//ĂDMARg[ǂݍޑOɑ҂
}



*/

/*
Example 31-2: DMA Channel Initialization in Pattern Match TransferMode Code Example
The following code example illustrates the DMA channel 0 configuration for data transfer with
pattern match enabled. Transfer from the UART1 a <CR> ended string, at most 200 characters long
*/
void dma_test_2()
{
	IEC1CLR=0x00020000; // disable DMA channel 0 interrupts
	IFS1CLR=0x00020000; // clear any existing DMA channel 0 interrupt flag
	IEC1CLR=0x00010000; // disable DMA channel 0 interrupts
	IFS1CLR=0x00010000; // clear any existing DMA channel 0 interrupt flag
	DMACONSET=0x00008000; // enable the DMA controller
	DCH0CON=0x03; // channel off, priority 3, no chaining
	DCH0ECON=(27 <<8)| 0x30; // start irq is UART1 RX, pattern match enabled
	DCH0DAT='\r'	; // pattern value, carriage return
// program the transfer
	DCH0SSA=VirtToPhys(&U1RXREG); // transfer source physical address
	DCH0DSA=0x1d020000; // transfer destination physical address
	DCH0SSIZ=1; // source size is 1 byte
	DCH0DSIZ=200; // destination size at most 200 bytes
	DCH0CSIZ=1; // one byte per UART transfer request
	DCH0INTCLR=0x00ff00ff; // clear existing events, disable all interrupts
	DCH0INTSET=0x00090000; // enable Block Complete and error interrupts
	IPC9CLR=0x00001f00; // clear the DMA channel 0 priority and sub-priority
	IPC9SET=0x00001600; // set IPL 5, sub-priority 2
	IPC9CLR=0x0000001f; // clear the DMA channel 0 priority and sub-priority
	IPC9SET=0x00000016; // set IPL 5, sub-priority 2
	IEC1SET=0x00020000; // enable DMA channel 0 interrupt
	IEC1SET=0x00010000; // enable DMA channel 0 interrupt
	DCH0CONSET=0x80; // turn channel on

}

/*
31-2F
p^[
      }b`][h̃R[hłDMA`l̏
     ̃R[hł́AƂ̃f[^]̂߂DMA`l0̍\
             }ł
             p^[
                     }b`LɂȂĂ܂B UART1 <CR>̓]́Aő200̒AI܂
     IEC1CLR = 0x00020000;
     // DMA`l0̊荞݂𖳌ɂ
     IFS1CLR = 0x00020000;
     //DMA`l0̊荞݃tONA
     IEC1CLR = 0x00010000;
     // DMA`l0̊荞݂𖳌ɂ
     IFS1CLR = 0x00010000;
     //DMA`l0̊荞݃tONA
     DMACONSET = 0x00008000;
     // DMARg[L
     DCH0CON = 0x03;
     //`lItADx3A`F[
     DCH0ECON =i27 << 8j| 0x30;
     //X^[gIRQUART1 RXALp^[
     }b`ł
     DCH0DAT = '\ r';
                   //p^[lALbW^[
                   //vO̓]
                   DCH0SSA = VirtToPhysiU1RXREGj//]̕AhX
       DCH0DSA = 0x1d020000;
                   //]̕AhX
                   DCH0SSIZ = 1;
                   //\[X̃TCY1oCgł
                   DCH0DSIZ = 200;
                   قƂǂ200oCg//̃TCY
                   DCH0CSIZ = 1;
                   UART]vƂ// 1oCg
DCH0INTCLR = 0x00ff00ff;
             //NÃCxgAׂĂ̊荞݂𖳌ɂ
             DCH0INTSET = 0x00090000;
             //ubNAG[荞݂
             IPC9CLR = 0x00001f00;
             // DMA`l0DxƃTuDxNA
             IPC9SET = 0x00001600;
             // IPL 5ATuDx2ݒ
             IPC9CLR = 0x0000001F;
             // DMA`l0DxƃTuDxNA
             IPC9SET = 0x00000016;
             // IPL 5ATuDx2ݒ
             IEC1SET = 0x00020000;
             //LDMA`l0荞
             IEC1SET = 0x00010000;
             //LDMA`l0荞
             DCH0CONSET = 0x80;
             //^[`l

/*
31-3F
                      The following code example illustrates the DMA channel 0 configuration for data transfer with
                      pattern match enabled. DMA channel 0 transfer from the UART1 to a RAM buffer while DMA channel 1
                      transfers data from the RAM buffer to UART2. Transferred strings are at most 200 characters
                      long. Transfer on UART2 will start as soon as the UART1 transfer is completed.
*/
void dma_test_3()
{
	unsigned char myBuff[200]; // transfer buffer
	IEC1CLR=0x00020000; // disable DMA channel 0 interrupts
	IFS1CLR=0x00020000; // clear any existing DMA channel 0 interrupt flag
	IEC1CLR=0x00010000; // disable DMA channel 0 interrupts
	IFS1CLR=0x00010000; // clear any existing DMA channel 0 interrupt flag
	DMACONSET=0x00008000; // enable the DMA controller
	DCH0CON=0x3; // channel 0 off, priority 3, no chaining
	DCH1CON=0x62; // channel 1 off, priority 2
// chain to higher priority
// (channel 0), enable events detection while disabled
	DCH0ECON=(27 <<8)| 0x30; // start IRQ is UART1 RX, pattern enabled
	DCH1ECON=(42 <<8)| 0x30; // start IRQ is UART1 TX, pattern enabled
	DCH0DAT=DCH1DAT='\r' ; // pattern value, carriage return
// program channel 0 transfer
	DCH0SSA=VirtToPhys(&U1RXREG); // transfer source physical address
	DCH0DSA=VirtToPhys(myBuff); // transfer destination physical address
	DCH0SSIZ=1; // source size is 1 byte
	DCH0DSIZ=200; // dst size at most 200 bytes
	DCH0CSIZ=1; // one byte per UART transfer request
// program channel 1 transfer
	DCH1SSA=VirtToPhys(myBuff); // transfer source physical address
	DCH1DSA=VirtToPhys(&U2TXREG); // transfer destination physical address
	DCH1SSIZ=200; // source size at most 200 bytes
	DCH1DSIZ=0; // dst size is 1 byte
	DCH1CSIZ=1; // one byte per UART transfer request
	DCH0INTCLR=0x00ff00ff; // DMA0: clear events, disable interrupts
	DCH1INTCLR=0x00ff00ff; // DMA1: clear events, disable interrupts
	DCH1INTSET=0x00090000; // DMA1: enable Block Complete and error interrupts
	IPC9CLR=0x001f1f00; // clear the DMA channels 0 and 1 priority and
// sub-priority
	IPC9SET=0x000b1600; // set IPL 5, sub-priority 2 for DMA channel 0
// set IPL 2, sub-priority 3 for DMA channel 1
	IPC9CLR=0x00001f1f; // clear the DMA channels 0 and 1 priority and
// sub-priority
	IPC9SET=0x00000b16; // set IPL 5, sub-priority 2 for DMA channel 0
// set IPL 2, sub-priority 3 for DMA channel 1
	IEC1SET=0x00040000; // enable DMA channel 1 interrupt
	IEC1SET=0x00020000; // enable DMA channel 1 interrupt
	DCH0CONSET=0x80; // turn channel on
}
/*
             A[h̃R[hłDMA`l̏
       ̃R[hł́AƂ̃f[^]̂߂DMA`l0̍\
               }ł
               p^[
 }b`LɂȂĂ܂B UART1RAMobt@ւDMA`l0̓]΂炭DMA`l1
                     RAMobt@UART2Ƀf[^]B ]͍ő200ł
             B UART2œ]ƂUART1]ƊJn܂B
unsigned char^myBuff <200>;
//]obt@
IEC1CLR = 0x00020000;
          // DMA`l0̊荞݂𖳌ɂ
          IFS1CLR = 0x00020000;
                    //DMA`l0̊荞݃tONA
                    IEC1CLR = 0x00010000;
        // DMA`l0̊荞݂𖳌ɂ
        IFS1CLR = 0x00010000;
                  //DMA`l0̊荞݃tONA
                  DMACONSET = 0x00008000;
    // DMARg[L
    DCH0CON = 0x3;
            //`l0ItADx3A`F[
            DCH1CON = 0x62;
                    //`l1ItADx2
                    D揇//`F[
                    ɂȂĂԁA//i`l0jACxgoL
                    DCH0ECON =i27 << 8j| 0x30;
      //X^[gIRQUART1 RXALȃp^[łB
      DCH1ECON =i42 << 8j| 0x30;
              //X^[gIRQUART1 TXALȃp^[łB
              DCH0DAT = DCH1DAT = '\ r';
                      //p^[lALbW^[
                      //vO`l0̓]
                      DCH0SSA = VirtToPhysiU1RXREGj//]̕AhX
        DCH0DSA = VirtToPhysimyBuffj;
                //]̕AhX
                DCH0SSIZ = 1;
  //\[X̃TCY1oCgł
  DCH0DSIZ = 200;
          قƂǂ200oCg// dst̃TCY
          DCH0CSIZ = 1;
                  UART]vƂ// 1oCg
                  //vO̓`l1̓]
                  DCH1SSA = VirtToPhysimyBuffj;
    //]̕AhX
    DCH1DSA = VirtToPhysiU2TXREGjA//]̕AhX
            DCH1SSIZ = 200;
                    قƂǂ200oCgŁA//\[X̃TCY
                    DCH1DSIZ = 0;
      // dst̃TCY1oCgł
      DCH1CSIZ = 1;
              UART]vƂ// 1oCg
              DCH0INTCLR = 0x00ff00ff;
                      // DMA0FmȃCxǵA荞݂֎~
                      DCH1INTCLR = 0x00ff00ff;
        // DMA1FmȃCxǵA荞݂֎~
        DCH1INTSET = 0x00090000;
                // DMA1́FSubNAG[荞݂
                IPC9CLR = 0x001f1f00;
  // DMA`l01̗DxNAāA
  //TuD
  IPC9SET = 0x000b1600;
          // DMA`l0 IPL 5ATuDx2ݒ
          // DMA`l1 IPL 2ATuDx3ݒ
          IPC9CLR = 0x00001f1f;
                  // DMA`l01̗DxNAāA
                  //TuD
                  IPC9SET = 0x00000b16;
    // DMA`l0 IPL 5ATuDx2ݒ
    // DMA`l1 IPL 2ATuDx3ݒ
    IEC1SET = 0x00040000;
            //LDMA`l1荞
            IEC1SET = 0x00020000;
                    //LDMA`l1荞
                    DCH0CONSET = 0x80;
      //^[`l
*/

